//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAF010203B2.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAF010203B2.cm

//## begin module%3DAF010203B2.cp preserve=no
//## end module%3DAF010203B2.cp

//## Module: PlotChiSq%3DAF010203B2; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotChiSq.cxx

//## begin module%3DAF010203B2.additionalIncludes preserve=no
//## end module%3DAF010203B2.additionalIncludes

//## begin module%3DAF010203B2.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>

#include <XSContainer.h>
#include <XSstreams.h>
#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/StatMethod.h>
#include <XSUtil/Utils/XSstream.h>
//## end module%3DAF010203B2.includes

// PlotChiSq
#include <XSPlot/Commands/PlotChiSq.h>
//## begin module%3DAF010203B2.declarations preserve=no
//## end module%3DAF010203B2.declarations

//## begin module%3DAF010203B2.additionalDeclarations preserve=yes
//## end module%3DAF010203B2.additionalDeclarations


// Class PlotChiSq 

PlotChiSq::PlotChiSq()
  //## begin PlotChiSq::PlotChiSq%3DAEFC7302F0_const.hasinit preserve=no
  //## end PlotChiSq::PlotChiSq%3DAEFC7302F0_const.hasinit
  //## begin PlotChiSq::PlotChiSq%3DAEFC7302F0_const.initialization preserve=yes
  : PlotCommand("chisq", new CreateBinnedPlotGroups(false, false))
  //## end PlotChiSq::PlotChiSq%3DAEFC7302F0_const.initialization
{
  //## begin PlotChiSq::PlotChiSq%3DAEFC7302F0_const.body preserve=yes
   isDataRequired(true);
   isActiveModelRequired(true);
   isDivisibleByArea(false);
   addCompLevel(0);
   isBackgroundApplicable(false);
   
   PlotAttributes styles;
   styles.symbolStyle = PlotStyle::BLANK;
   styles.lineStyle = PlotCommand::standardModelStyle();
   styles.lineStep = true;
   setStyleMap(PlotStyle::DATA, styles);
   
  //## end PlotChiSq::PlotChiSq%3DAEFC7302F0_const.body
}


PlotChiSq::~PlotChiSq()
{
  //## begin PlotChiSq::~PlotChiSq%3DAEFC7302F0_dest.body preserve=yes
  //## end PlotChiSq::~PlotChiSq%3DAEFC7302F0_dest.body
}



//## Other Operations (implementation)
void PlotChiSq::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotChiSq::makeLabels%4B1D2A11026F.body preserve=yes
  StatMethod* stat = XSContainer::fit->statMethod();
  if (stat->fullName() == string("C-Statistic") ||
      stat->fullName() == string("L-statistic"))
  {
     tcout <<"Note: When using cstat or lstat, \"plot chisq\" is only valid\n"
           <<"      for data sets with no background files." << std::endl;
  }
  labels.title = settings.lookupLabelName("t:chisq") + " " + stat->fullName();
  
  settings.makeXOptionDependentLabel(labels.x);
  labels.y = settings.lookupLabelName("y:chisq") + " " + stat->scriptName();
  //## end PlotChiSq::makeLabels%4B1D2A11026F.body
}

void PlotChiSq::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotChiSq::manipulate%4B1D2A310283.body preserve=yes
   StatMethod* stat = XSContainer::fit->statMethod();
   const Real NO_VAL = settings.badDataValue();
   for (size_t i=0; i<plotGroups.size(); ++i)
   {
      PlotGroup* pg = plotGroups[i];
      size_t arraySize = pg->n;
      const std::vector<Real>& X      = pg->xAxis.data;
      std::vector<Real>& yData  = pg->yData.data;
      const std::vector<Real>& yError = pg->yData.errors[0];
      const std::vector<Real>& model  = pg->model[0].data;
      for (size_t j=0; j<arraySize; ++j)
      {
         Real obs (yData[j]);
         Real mod (model[j]);
         Real err (yError[j]);
         Real areaTime = pg->saveData[j];
         yData[j]  = stat->plotChi(obs,mod,err,areaTime, NO_VAL);         
      }
      pg->yData.errors.resize(0);    
   }
  //## end PlotChiSq::manipulate%4B1D2A310283.body
}

void PlotChiSq::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotChiSq::setRanges%4B1D2A3703C7.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   
   rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   
   // Draw a horizontal line at y = 0.0
   rangeVals.horizontalLine.first = true;
   rangeVals.horizontalLine.second = 0.0;
  //## end PlotChiSq::setRanges%4B1D2A3703C7.body
}

// Additional Declarations
  //## begin PlotChiSq%3DAEFC7302F0.declarations preserve=yes
  //## end PlotChiSq%3DAEFC7302F0.declarations

//## begin module%3DAF010203B2.epilog preserve=yes
//## end module%3DAF010203B2.epilog
